#!/usr/bin/python

#Binary of Babel
#Copyright (C) 2010 Segfault Garden
#
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.


import sys
import struct

width = int(sys.argv[1])
height = int(sys.argv[2])

sys.stderr.write("test.py: args %d %d\n" % (width, height))

while (True):
    time_bin = sys.stdin.read(4)
    # See if input closed
    if len(time_bin) == 0:
        sys.stderr.write('Received EOF from input\n')
        break;
    
    time = struct.unpack('=I', time_bin)[0]
    timemod = int((time % 1000) * 0.255)

    pixel_out = struct.pack('cccc', chr(timemod), chr(timemod), chr(timemod), chr(255))
    sys.stdout.write(pixel_out * width * height)
    
