/*
Binary of Babel
Copyright (C) 2010 Segfault Garden

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DEMOLIB_H
#define DEMOLIB_H

/* This file contains miscellaneous helper functions. */

enum logLevel {
    traceLevel, // Very detailed logging.
    debugLevel, // General state transitions, scenes starting etc.
    messageLevel, // Messages a non-technical end user cares about.
    errorLevel, // Only errors are printed.
    silenceLevel // Nothing at all is printed.
};

void log_print(enum logLevel level, const char *fmt, ...);
void set_logging_level(enum logLevel newLevel);

#endif
