/*
Binary of Babel
Copyright (C) 2010 Segfault Garden

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include<stdlib.h>
#include"pluginapi.h"

/* This is a demo plugin that on every frame generates a random texture */

/* Global variables are fun. */
int w, h;

void init(int width, int height, const char *config_file) {
    w = width;
    h = height;
}

void render(unsigned char *texture, uint32_t time_in_milliseconds) {
    int i, j;
    unsigned char r, g, b;
    r = random();
    g = random();
    b = random();
    for(i=0; i<w; i++) {
        for(j=0; j<h; j++) {
            int offset = (j*w + i)*4;
            texture[offset] = r;
            texture[offset+1] = g;
            texture[offset+2] = b;
            texture[offset+3] = 255;
        }
    }
}

void gc(void) {
}

void shutdown(void) {
}
