/*
Binary of Babel
Copyright (C) 2010 Segfault Garden

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#import <objc/Object.h>

@interface Roto : Object {
  unsigned char *src;
  int w, h, wMask, hMask;
  int srcXOff, srcYOff, dstXOff, dstYOff;
}

- free;
- print;
- (Roto*) setW: (int) wi  andH:(int) h  andP:(unsigned char *) pixels;
- (Roto*) setSrcXOff: (int) sxo andYOff: (int) syo;
- (Roto*) setDstXOff: (int) dxo andYOff: (int) dyo;
- (Roto*) rotate: (double) angle andZoom: (double) zoom andDst: (unsigned char*) dst;
@end
